package net.ivoa.adql;

import java.util.Vector;

import net.ivoa.adql.exceptions.DBObjectNotFoundException;
import net.ivoa.adql.exceptions.TableItemNotFoundException;

public class SearchCondition implements GetTableCorrespondItems{
	final int ONLY_CONTAIN_CURR= 1;
	final int CONTAIN_OTHERS=2;
	final int FAULT=3;
	final int NOT_CONTAINS=0;
	static final public int TP_AND=0x0000;
	static final public int TP_OR=0x0001;
	static final public int TP_NOT=0x1002;
	static final public int TP_COMPAREOP=0x0103;
	static final public int TP_REGION=0x0104;
	static final public int TP_XMATCH=0x0105;
	protected int type=-1;
	public ADQLToken terminator=null;
	public int getType(){
		return type;
	}
	public int containsTables(Vector AllTableAliasList)throws TableItemNotFoundException{
		return 0;
	}
	public DBObject[] getAllDBObjects()throws DBObjectNotFoundException{
		return null;
	}
	public DBObject[] getAllDBObjectsWithoutCurrDN(Vector currDNTableAlias)throws TableItemNotFoundException, DBObjectNotFoundException{
		return null;
	}
	public void replaceName(String oldname, String newname){
		
	}
	public String getADQLString(){
		return null;
	}
	public void setLeft(SearchCondition sc){
		
	}
	public void setRight(SearchCondition sc){
		
	}
	public void setParent(SearchCondition sc){
		
	}
	public SearchCondition getLeft(){
		return null;
	}
	public SearchCondition getRight(){
		return null;
	}
	public SearchCondition getParent(){
		return null;
	}
	public int priority(){
		int p=0;
		if(isOperator()){
			p=type&0x1000;
		}
		return p;
	}
	public boolean isOperator(){
		boolean b=((type&0x0100)==0);
		return b;
	}
	static public SearchCondition[] add(SearchCondition scroot, SearchCondition sccurr, SearchCondition scnew){
		SearchCondition[] rsc={null,null};
		if(scnew.isOperator()){
			if(sccurr==null){
				scnew.setLeft(scroot);
				rsc[0]=scnew;
				rsc[1]=scnew;
			}
			else{
				if(sccurr.priority()<scnew.priority()){
					scnew.setLeft(sccurr.getRight());
					sccurr.setRight(scnew);
					sccurr=scnew;
				}
				else{
					SearchCondition scpar=sccurr.getParent();
					if(scpar!=null){
						while(scpar.priority()>=scnew.priority()){
							scpar=scpar.getParent();
							if(scpar==null){
								break;
							}
						}
					}
					if(scpar!=null){
						scnew.setLeft(scpar);
					//	scpar.setRight(scnew);
						scroot=scnew;
						sccurr=scnew;
					}
					else{
						scnew.setLeft(scroot);
						scroot=scnew;
						sccurr=scroot;
					}
				}
				rsc[0]=scroot;
				rsc[1]=sccurr;
			}
		}
		else{
			if(scroot==null){
				rsc[0]=scnew;
				rsc[1]=null;
			}
			else{
				sccurr.setRight(scnew);
				rsc[0]=scroot;
				rsc[1]=sccurr;
			}
		}
		return rsc;
	}
}
