package org.china.vo.das.engine.impl; 

import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.impl.ResourceHomeImpl;
import org.globus.wsrf.impl.SimpleResourceKey;
import org.china.vo.das.engine.WaitingQueue;

public class DASResourceHome extends ResourceHomeImpl {

	public ResourceKey create() throws Exception {
		DASResource resource = (DASResource)createNewInstance();
		resource.create();
		ResourceKey key = new SimpleResourceKey(keyTypeName, resource.getID());
		WaitingQueue instance = WaitingQueue.getInstance();
		instance.getWaitingQueue().add(resource);
		add(key, resource);
		return key;
	}
}
