package org.china.vo.das.registry;

import java.io.*; // For reading the input file

import org.w3c.dom.*; // W3C DOM classes for traversing the document
import org.xml.sax.*; // SAX classes used for error handling by JAXP

import javax.xml.parsers.*; // JAXP classes for parsing
import javax.xml.transform.*; // For transforming a DOM tree to an XML file.

public class TestXML {

	org.w3c.dom.Document document; // This field holds the parsed DOM tree

	int numservlets;

	NodeList servletnodes = null;

	public TestXML(String fname) throws IOException, SAXException,
			ParserConfigurationException {

		File configfile = new File(fname);
		javax.xml.parsers.DocumentBuilderFactory dbf = DocumentBuilderFactory
				.newInstance();
		// Tell the factory what kind of parser we want
		dbf.setValidating(false);
		// Use the factory to get a JAXP parser object
		javax.xml.parsers.DocumentBuilder parser = dbf.newDocumentBuilder();

		// Tell the parser how to handle errors. Note that in the JAXP API,
		// DOM parsers rely on the SAX API for error handling
		parser.setErrorHandler(new org.xml.sax.ErrorHandler() {
			public void warning(SAXParseException e) {
				System.err.println("WARNING: " + e.getMessage());
			}

			public void error(SAXParseException e) {
				System.err.println("ERROR: " + e.getMessage());
			}

			public void fatalError(SAXParseException e) throws SAXException {
				System.err.println("FATAL: " + e.getMessage());
				throw e; // re-throw the error
			}
		});

		// Finally, use the JAXP parser to parse the file. This call returns
		// A Document object. Now that we have this object, the rest of this
		// class uses the DOM API to work with it; JAXP is no longer required.
		document = parser.parse(configfile);
		// if (document.getElementsByTagName("DBResource2") == null)
		// System.out
		// .println("document.getElementsByTagName(\"DBResource2\")==null");

		NodeList servletnodes = document.getElementsByTagName("TABLE");
		numservlets = servletnodes.getLength();
		System.out.println(numservlets);

		Element tableTag = (Element) servletnodes.item(0);
		System.out.println(RegistryProxy.getNodeValue(tableTag, "DESCRIPTION"));
//		System.out.println(tableTag.hasAttributes()); 
		String tableName = tableTag.getAttribute("name");
		System.out.println(tableName);
		
		NodeList fieldList = tableTag.getElementsByTagName("FIELD");
		System.out.println(fieldList.getLength());
//		int listNum = fieldList.getLength();
		
//		Node namenodeC = fieldList.item(5).getAttributes().getNamedItem("ucd").getFirstChild();
////		Node namenodeC = namenode.getFirstChild();
////		System.out.println(namenodeC.hasChildNodes());
//		String namedata = ((Text)namenodeC).getData().trim();
//		System.out.println(namedata);
//		
		String namedata2 = ((Element)(fieldList.item(0))).getAttribute("ucd");
		System.out.println("the ucd\t"+namedata2);
		
		
		System.out.println(fieldList.item(5).hasChildNodes());
		Element decTag = (Element)fieldList.item(5);
		NodeList declist =decTag.getElementsByTagName("DESCRIPTION");
		System.out.println(declist.getLength());
		System.out.println(declist.item(0).hasChildNodes());
		String dec = ((Text)(declist.item(0).getFirstChild())).getData().trim();
		System.out.println(dec);
		
		MDTable mdt = new MDTable();
		System.out.println("columns number is :"+mdt.getColumnsNum());
		
//		System.out.println(decTag.hasChildNodes());
//		String dec = ((Text)decTag).getTextContent();
//		System.out.println(dec);
//		
		
//		String namedata = ((Text)aTag2).getData().trim();
//		System.out.println(namedata);
//		NodeList inlist = ((Element)aTag2).getElementsByTagName("name");
//		System.out.println(inlist.getLength());
//		int inlistNum = inlist.getLength();
//		Node nameTag = inlist.item(0);
//		System.out.println(nameTag.hasChildNodes());
//		String namedata = ((Text)nameTag).getData().trim();
//		System.out.println(namedata);
		
		
//		for(int i = 0;i < listNum;i++)
//		{
//			Node aTag2 = alist.item(i);
//			String data = ((Text) (aTag2.getFirstChild())).getData().trim();
//			System.out.println(data);
//		}
		
		
		// Element aTag = (Element) dbrTag.getElementsByTagName(
		// "DESCRIPTION").item(0);
		// // Node n1 = dbrTag.getElementsByTagName(
		// // "CurationPublisherDescription").item(0);
		// // System.out.println(n1);
		//
		// // String tagvalue = ((Text) aTag.getFirstChild()).getData().trim();
		// // System.out.println(tagvalue);
		// String tagvalue = "";
		// if (aTag.getFirstChild() == null)
		// System.out.println("The tag is null!!");
		// else
		// tagvalue = ((Text) aTag.getFirstChild()).getData().trim();
		// System.out.println(tagvalue);
		// }

		// public void makeMDdr() {
		//
		// for (int i = 0; i < numservlets; i++) {
		//
		// MDDataResource dr = new MDDataResource();
		// MDItemDataQuality itemdataQ = new MDItemDataQuality();
		// MDItemIdentity itemItemI = new MDItemIdentity();
		// MDItemCuration itemCuration = new MDItemCuration();
		// MDItemGeneralContent itemG = new MDItemGeneralContent();
		// MDItemService itemS = new MDItemService();
		// MDItemCollection itemCollection = new MDItemCollection();
		// MDItemServiceInterface itemSI = new MDItemServiceInterface();
		// MDItemServiceCapibility itemSC = new MDItemServiceCapibility();
		// MDItemResolution itemR = new MDItemResolution();
		// MDItemCoverage itemCoverage = new MDItemCoverage();
		//
		// }

	}

	public String getValue(int drNum, String tagName) {
		Element dbrTag = (Element) servletnodes.item(drNum);
		Element aTag = (Element) dbrTag.getElementsByTagName(tagName).item(0);
		String tagvalue = ((Text) aTag.getFirstChild()).getData().trim();
		// System.out.println(tagvalue);

		return tagvalue;
	}

	public static void main(String[] args) throws Exception {
		try {
			TestXML txml = new TestXML("F:\\Temp\\votable_3galx_delData.xml");
		} catch (Exception e) {
			System.err.println(e);
		}

	}
}
